<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en" dir="ltr">
	<head>
		<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
		<meta http-equiv="Content-Style-Type" content="text/css" />
		<meta name="keywords" content="Learn, Erlang, Programming, Functional, Actor Model, Development Environment, Scaling, Introduction, Tutorial" />
		<meta name="description" content="A look over major aspects of Erlang such as messages, Concurrency, functional ideas, the actor model, etc." />
        <meta name="google-site-verification" content="mi1UCmFD_2pMLt2jsYHzi_0b6Go9xja8TGllOSoQPVU" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/screen.css?v3" media="screen" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/sh/shCore.css" media="screen" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/sh/shThemeLYSE2.css" media="screen" />
		<link rel="stylesheet" type="text/css" href="https://learnyousomeerlang.com/static/css/print.css" media="print" />
		<link href="https://learnyousomeerlang.com/rss" type="application/rss+xml" rel="alternate" title="LYSE news" />
		<link rel="icon" type="image/png" href="https://learnyousomeerlang.com/favicon.ico" />
		<link rel="apple-touch-icon" href="https://learnyousomeerlang.com/static/img/touch-icon-iphone.png" />
		<link rel="apple-touch-icon" sizes="72x72" href="https://learnyousomeerlang.com/static/img/touch-icon-ipad.png" />
		<link rel="apple-touch-icon" sizes="114x114" href="https://learnyousomeerlang.com/static/img/touch-icon-iphone4.png" />
		<title>Introduction | Learn You Some Erlang for Great Good!</title>
	</head>
	<body>
		<div id="wrapper">
			<div id="header">
				<h1>Learn you some Erlang</h1>
				<span>for great good!</span>
			</div> <!-- header -->
			<div id="menu">
				<ul>
					<li><a href="https://learnyousomeerlang.com/content" title="Home">Home</a></li>
					<li><a href="https://learnyousomeerlang.com/faq" title="Frequently Asked Questions">FAQ</a></li>
					<li><a href="https://learnyousomeerlang.com/rss" title="Latest News">RSS</a></li>
					<li><a href="https://learnyousomeerlang.com/static/erlang/learn-you-some-erlang.zip" title="Source Code">Code</a></li>
				</ul>
			</div><!-- menu -->
			<div id="content">
            <div class="noscript"><noscript>Hey there, it appears your Javascript is disabled. That's fine, the site works without it. However, you might prefer reading it with syntax highlighting, which requires Javascript!</noscript></div>
<h2>Introduction</h2>
<h3><a class="section" name="about-this-tutorial">About this tutorial</a></h3>

<p>This is the beginning of Learn You Some Erlang for Great Good! Reading this tutorial should be one of your first steps in learning Erlang, so let's talk about it a bit.</p>

<img class="left" src="https://learnyousomeerlang.com/static/img/erlang.png" width="132" height="112" alt="Erlang logo" />

<p>First of all, I began growing the idea of writing this after reading Miran Lipovača's <a class="external" href="http://learnyouahaskell.com/" title="Free Book!">Learn You a Haskell for great Good! (LYAH)</a> tutorial; I thought he did a great job making the language attractive and the learning experience friendly. As I already knew him, I asked him how he felt about me writing an Erlang version of his book. He liked the idea, being somewhat interested in Erlang.</p>

<p>So here I am typing this. Of course there were other sources to my motivation: I mainly find the entry to the language to be hard (the web has sparse documentation and otherwise you need to buy books), and I thought the community would benefit from a LYAH-like guide. Less importantly, I've seen people attributing Erlang too much or not enough merit sometimes based on sweeping generalizations. Then there are people who sure as hell believe Erlang is nothing but hype. If I'd like to convince them otherwise, I know they're not likely to read this in the first place.</p>

<p>This book thus wants itself to be a way to learn Erlang for people who have basic knowledge of programming in imperative languages (such as C/C++, Java, Python, Ruby, etc) and may or may not know functional programming (Haskell, Scala, Erlang, Clojure, OCaml...). I also want to write this book in a honest manner, selling Erlang for what it is, acknowledging its weaknesses and strengths.</p>


<h3><a class="section" name="what-is-erlang">So what's Erlang?</a></h3>
<p>First of all, Erlang is a functional programming language. If you have ever worked with imperative languages, statements such as <code>i++</code> may be normal to you; in functional programming they are not allowed. In fact, changing the value of any variable is strictly forbidden! This may sound weird at first, but if you remember your math classes, it's in fact how you've learned it:</p>
<pre class="brush:eshell">
y = 2
x = y + 3
x = 2 + 3
x = 5
</pre>
<p>Had I added the following:</p>
<pre class="brush:eshell">
x = 5 + 1
x = x
&there4; 5 = 6
</pre>
<p>You would have been very confused. Functional programming recognizes this: If I say <var>x</var> is 5, then I can't logically claim it is also 6! This would be dishonest. This is also why a function with the same parameter should always return the same result:</p>
<pre class="brush:eshell">
x = add_two_to(3) = 5
&there4; x = 5
</pre>
<p>Functions always returning the same result for the same parameter is called referential transparency. It's what lets us replace <code>add_two_to(3)</code> with 5, as the result of <code>3+2</code> will always be 5. That means we can then glue dozens of functions together in order to resolve more complex problems while being sure nothing will break. Logical and clean isn't it? There's a problem though:</p>
<pre class="brush:eshell">
x = today() = 2009/10/22
  -- wait a day --
x = today() = 2009/10/23
x = x
&there4; 2009/10/22 = 2009/10/23
</pre>
<p>Oh no! My beautiful equations! They suddenly all turned wrong! How come my function returns a different result every day?</p>
<p>Obviously, there are some cases where it's useful to break referential transparency. Erlang has this very pragmatic approach with functional programming: obey its purest principles (referential transparency, avoiding mutable data, etc), but break away from them when real world problems pop up.</p>

<img class="right" src="https://learnyousomeerlang.com/static/img/envelope.png" width="206" height="161" alt="An envelope" />

<p>Now, we defined Erlang as a functional programming language, but there's also a large emphasis on concurrency and high reliability. To be able to have dozens of tasks being performed at the same time, Erlang uses the <a class="external" href="http://en.wikipedia.org/wiki/Actor_model" title="A more technical definition">actor model</a>, and each actor is a separate process in the virtual machine. In a nutshell, if you were an actor in Erlang's world, you would be a lonely person, sitting in a dark room with no window, waiting by your mailbox to get a message. Once you get a message, you react to it in a specific way: you pay the bills when receiving them, you respond to Birthday cards with a "Thank you" letter and you ignore the letters you can't understand.</p>

<p>Erlang's actor model can be imagined as a world where everyone is sitting alone in their own room and can perform a few distinct tasks. Everyone communicates strictly by writing letters and that's it. While it sounds like a boring life (and a new age for the postal service), it means you can ask many people to perform very specific tasks for you, and none of them will ever do something wrong or make mistakes which will have repercussions on the work of others; they may not even know the existence of people other than you (and that's great).</p>
<p>To escape this analogy, Erlang forces you to write actors (processes) that will share no information with other bits of code unless they pass messages to each other. Every communication is explicit, traceable and safe.</p>

<p>When we defined Erlang, we did so at a language level, but in a broader sense, this is not all there is to it: Erlang is also a development environment as a whole. The code is compiled to bytecode and runs inside a virtual machine. So Erlang, much like Java and kids with ADD, can run anywhere. The standard distribution includes (among others) development tools (compiler, debugger, profiler, test framework), the Open Telecom Platform (OTP) Framework, a web server, a parser generator, and the mnesia database, a key-value storage system able to replicate itself on many servers, supporting nested transactions and letting you store any kind of Erlang data.</p>
<p>The VM and the libraries also allow you to update the code of a running system without interrupting any program, distribute your code with ease on many computers and manage errors and faults in a simple but powerful manner.</p>

<img class="right" src="https://learnyousomeerlang.com/static/img/letitcrash.png" width="206" height="320" alt="A crashed plane" title="Don't do this" />

<p>We'll see how to use most of these tools and achieve safety later on, but for now, I'll tell you about a related general policy in Erlang: Let it crash. Not like a plane with dozens of passengers dying, but more like a tightrope walker with a safety net under him. While you should avoid making mistakes, you won't need to check for every type or error condition in most cases.</p>

<p>Erlang's ability to recover from errors, organize code with actors and making it scale with distribution and concurrency all sound awesome, which brings us to the next section...</p>

<h3><a class="section" name="kool-aid">Don't drink too much Kool-Aid</a></h3>

<p>There may be many little yellowish-orange sections named like this one around the book (you'll recognize them when you see them). Erlang is currently gaining lots of popularity due to zealous talks which may lead people to believe it's more than what it really is. These reminders will be there to help you keep your feet on the ground if you're one of these overenthusiastic learners.</p>

<p>The first case of this is related to Erlang's massive scaling abilities due to its lightweight processes. It is true that Erlang processes are very light:  you can have hundreds of thousands of them existing at the same time, but this doesn't mean you have to use it that way just because you can. For example, creating a shooter game where everything including bullets is its own actor is madness. The only thing you'll shoot with a game like this is your own foot.  There is still a small cost in sending a message from actor to actor, and if you divide tasks too much, <em>you will make things slower</em>!</p>

<p>I'll cover this with more depth when we're far enough into the learning to actually worry about it, but just keep in mind that randomly throwing parallelism at a problem is not enough to make it go fast. Don't be sad; there are times when using hundreds of processes will both be possible and useful! It's just not happening all the time.</p>

<p>Erlang is also said to be able to scale in a directly proportional manner to how many cores your computer has, but this is usually not true: <img class="left" src="https://learnyousomeerlang.com/static/img/scaling.png" width="220" height="185" alt="Bad Graph: Speed vs Cores: It just scales!" />
it is possible, but most problems do not behave in a way that lets you just run everything at the same time.</p>

<p>There's something else to keep in mind: while Erlang does some things very well, it's technically still possible to get the same results from other languages. The opposite is also true; evaluate each problem as it needs to be, and choose the right tool according to the problem being addressed. Erlang is no silver bullet and will be particularly bad at things like image and signal processing, operating system device drivers, etc. and will shine at things like large software for server use (i.e.: queues, map-reduce), doing some lifting coupled with other languages, higher-level protocol implementation, etc. Areas in the middle will depend on you. You should not necessarily wall yourself in server software with Erlang: there have been cases of people doing unexpected and surprising things. One example is IANO, a robot created by the UNICT team, which uses Erlang for its artificial intelligence and won the silver medal at the 2009 <a class="external" href="http://eurobot.dmi.unict.it/">eurobot competition</a>. Another example is Wings 3D, an open source 3D modeler (but not a renderer) written in Erlang and thus cross-platform.</p>


<h3><a class="section" name="what-you-need">What you need to dive in</a></h3>
<p>All you need to get started is a text editor and the Erlang environment. You can get the source code and the Windows binaries from <a class="external" href="http://erlang.org/download.html" title="official Erlang download page">the official Erlang website</a>. I won't go into much installation details, but for Windows, just download and run the binary files. Don't forget to add your Erlang directory to your <var>PATH</var> system variable to be able to access it from the command line.</p>

<p>On Debian-based Linux distributions, you should be able to install the package by doing <code>$ apt-get install erlang</code>. On Fedora (if you have 'yum' installed), you can achieve the same by typing <code># yum install erlang</code>. However, these repositories often hold outdated versions of the Erlang packages; Using an outdated version could give you some differences with what you'll get from this tutorial and a hit in performance with certain applications. I thus encourage you to compile from source. Consult the README file within the package and Google to get all the installing details you'll need, they'll do a far better job than I ever will.</p>

<p>On FreeBSD, many options are available to you. If you're using portmaster, you can do <code>portmaster lang/erlang</code>. For standard ports, it should be <code>cd /usr/ports/lang/erlang; make install clean</code>. Finally, if you want to use packages, run <code>pkg_add -rv erlang</code>.</p>

<p>If you're on OSX, you can install Erlang with <code>$ brew install erlang</code> (with <a class="external" href="https://github.com/Homebrew/homebrew">Homebrew</a>) or by doing <code>$ port install erlang</code> (if you prefer <a class="external" href="http://macports.org">MacPorts</a>.)</p>

<p>Alternatively, Erlang Solutions Ltd. offers <a class="external" href="https://www.erlang-solutions.com/resources/download.html">packages for all major OSes</a>, which generally work pretty well (pick a 'Standard' distribution).</p>

<div class="note">
	<p><strong>Note:</strong> at the time of this writing, I'm using Erlang version R13B+, but for best results, you should use newer ones.</p>
</div>


<h3><a class="section" name="get-help">Where to get Help</a></h3>
<p>There are a few places where you can get help. If you're using linux, you can access the man pages for good technical documentation. Erlang has a lists module (which we'll soon see): to get the documentation on lists, just type in <code>$ erl -man lists</code>.</p>

<p>On Windows, the installation should include HTML documentation. You can download it at any time from the <a class="external" href="http://erlang.org/doc/" title="Official Erlang HTML documentation">official erlang site</a>, or consult one of the <a class="external" href="http://erldocs.com/" title="Unofficial Erlang HTML documentation">cleaner alternative sites</a>.</p>

<p>Good coding practices can be found <a class="external" href="http://www.erlang.se/doc/programming_rules.shtml">here</a> once you feel you need to get everything clean. The code in this book will attempt to follow these guidelines, too.</p>

<p>Now, there are times where just getting the technical details isn't enough. When that happens, I tend to turn to two main sources: the official <a class="external" href="http://www.erlang.org/static/doc/mailinglist.html">mailing list</a> (you should follow it just to learn a bunch) and the <a class="external" href="irc://irc.freenode.net/erlang">#erlang</a> channel on <a class="external" href="http://freenode.net/">irc.freenode.net</a>.</p>

<p>Oh and if you're the type of person to go for cookbooks and pre-made recipes, <a class="external" href="http://trapexit.org/" title="trapexit, an Erlang community site">trapexit</a> is the place you're looking for. They also mirror the mailing lists as a forum and a general wiki, which can always be helpful.</p>
				<ul class="navigation">
											<li><a href="https://learnyousomeerlang.com/contents" title="Previous chapter">&lt; Previous</a></li>
										
					<li><a href="https://learnyousomeerlang.com/contents" title="Index">Index</a></li>
					
											<li><a href="https://learnyousomeerlang.com/starting-out" title="Next chapter">Next &gt;</a></li>
									</ul>
			</div><!-- content -->
			<div id="footer">
				<a href="http://creativecommons.org/licenses/by-nc-nd/3.0/" title="Creative Commons License Details"><img src="https://learnyousomeerlang.com/static/img/cc.png" width="88" height="31" alt="Creative Commons Attribution Non-Commercial No Derivative License" /></a>
				<p>Except where otherwise noted, content on this site is licensed under a Creative Commons Attribution Non-Commercial No Derivative License</p>
			</div> <!-- footer -->
		</div> <!-- wrapper -->
		<div id="grass" />
	<script type="text/javascript" src="https://learnyousomeerlang.com/static/js/shCore.js"></script>
	<script type="text/javascript" src="https://learnyousomeerlang.com/static/js/shBrushErlang2.js?11"></script>
	<script type="text/javascript">
		SyntaxHighlighter.defaults.gutter = false;
		SyntaxHighlighter.all();
	</script>
	</body>
</html>
